#include <stdio.h>
#include <Windows.h>

class CPUTimer
{
protected:
#ifdef XL_TIMER_ON
	LARGE_INTEGER m_li;
#endif
public:
	CPUTimer()
	{
		Reset();
	}
	void Print(FILE* file, const char* format)
	{
#ifdef XL_TIMER_ON
		static LARGE_INTEGER freq;
		static bool init = false;
		if(!init)
		{
			init = true;
			QueryPerformanceFrequency(&freq);
		}
		LARGE_INTEGER now;
		QueryPerformanceCounter(&now);
		fprintf(file, format, (now.QuadPart - m_li.QuadPart) / (double)freq.QuadPart);
#endif
	}
	void Reset()
	{
#ifdef XL_TIMER_ON
		QueryPerformanceCounter(&m_li);
#endif
	}
};