

#pragma once

#define _ASM_

#pragma intrinsic(_BitScanReverse)

inline int i_adds(XL_UINT32* dest, const XL_UINT32* src, XL_UINT32 len, int carry)
{
#ifdef _ASM_
	__asm
	{
		mov ebx, [src];
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		mov eax, [carry];
		test eax, eax;
		jnz setcarry;
		clc;
		pushf;
		jmp loopstart;
setcarry:
		stc;
		pushf;
loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
		test ecx, 10000b;
		jnz add16;
loopstart2:
		sub ecx, 20h;
		jge add32;
		jmp end_fun;
add1:
		popf;
		lodsd;
		adc eax, [ebx];
		stosd;
		pushf;
		add ebx, 04h;
		dec ecx;
		jmp loopstart;

add2:
		popf;
		lodsd;
		adc eax, [ebx];
		stosd;
		lodsd;
		adc eax, [ebx+04h];
		stosd;
		pushf;
		add ebx, 08h;
		sub ecx, 2h;
		jmp loopstart;

add4:
		popf;
		lodsd;
		adc eax, [ebx];
		stosd;
		lodsd;
		adc eax, [ebx+04h];
		stosd;
		lodsd;
		adc eax, [ebx+08h];
		stosd;
		lodsd;
		adc eax, [ebx+0Ch];
		stosd;
		pushf;
		add ebx, 10h;
		sub ecx, 4h;
		jmp loopstart;

add8:
		popf;
		lodsd;
		adc eax, [ebx];
		stosd;
		lodsd;
		adc eax, [ebx+04h];
		stosd;
		lodsd;
		adc eax, [ebx+08h];
		stosd;
		lodsd;
		adc eax, [ebx+0Ch];
		stosd;
		lodsd;
		adc eax, [ebx+10h];
		stosd;
		lodsd;
		adc eax, [ebx+14h];
		stosd;
		lodsd;
		adc eax, [ebx+18h];
		stosd;
		lodsd;
		adc eax, [ebx+1Ch];
		stosd;
		pushf;
		add ebx, 20h;
		sub ecx, 8h;
		jmp loopstart;

add16:
		popf;
		lodsd;
		adc eax, [ebx];
		stosd;
		lodsd;
		adc eax, [ebx+04h];
		stosd;
		lodsd;
		adc eax, [ebx+08h];
		stosd;
		lodsd;
		adc eax, [ebx+0Ch];
		stosd;
		lodsd;
		adc eax, [ebx+10h];
		stosd;
		lodsd;
		adc eax, [ebx+14h];
		stosd;
		lodsd;
		adc eax, [ebx+18h];
		stosd;
		lodsd;
		adc eax, [ebx+1Ch];
		stosd;
		lodsd;
		adc eax, [ebx+20h];
		stosd;
		lodsd;
		adc eax, [ebx+24h];
		stosd;
		lodsd;
		adc eax, [ebx+28h];
		stosd;
		lodsd;
		adc eax, [ebx+2Ch];
		stosd;
		lodsd;
		adc eax, [ebx+30h];
		stosd;
		lodsd;
		adc eax, [ebx+34h];
		stosd;
		lodsd;
		adc eax, [ebx+38h];
		stosd;
		lodsd;
		adc eax, [ebx+3Ch];
		stosd;
		pushf;
		add ebx, 40h;
		sub ecx, 10h;
		jmp loopstart;

add32:
		popf;
		lodsd;
		adc eax, [ebx];
		stosd;
		lodsd;
		adc eax, [ebx+04h];
		stosd;
		lodsd;
		adc eax, [ebx+08h];
		stosd;
		lodsd;
		adc eax, [ebx+0Ch];
		stosd;
		lodsd;
		adc eax, [ebx+10h];
		stosd;
		lodsd;
		adc eax, [ebx+14h];
		stosd;
		lodsd;
		adc eax, [ebx+18h];
		stosd;
		lodsd;
		adc eax, [ebx+1Ch];
		stosd;
		lodsd;
		adc eax, [ebx+20h];
		stosd;
		lodsd;
		adc eax, [ebx+24h];
		stosd;
		lodsd;
		adc eax, [ebx+28h];
		stosd;
		lodsd;
		adc eax, [ebx+2Ch];
		stosd;
		lodsd;
		adc eax, [ebx+30h];
		stosd;
		lodsd;
		adc eax, [ebx+34h];
		stosd;
		lodsd;
		adc eax, [ebx+38h];
		stosd;
		lodsd;
		adc eax, [ebx+3Ch];
		stosd;
		lodsd;
		adc eax, [ebx+40h];
		stosd;
		lodsd;
		adc eax, [ebx+44h];
		stosd;
		lodsd;
		adc eax, [ebx+48h];
		stosd;
		lodsd;
		adc eax, [ebx+4Ch];
		stosd;
		lodsd;
		adc eax, [ebx+50h];
		stosd;
		lodsd;
		adc eax, [ebx+54h];
		stosd;
		lodsd;
		adc eax, [ebx+58h];
		stosd;
		lodsd;
		adc eax, [ebx+5Ch];
		stosd;
		lodsd;
		adc eax, [ebx+60h];
		stosd;
		lodsd;
		adc eax, [ebx+64h];
		stosd;
		lodsd;
		adc eax, [ebx+68h];
		stosd;
		lodsd;
		adc eax, [ebx+6Ch];
		stosd;
		lodsd;
		adc eax, [ebx+70h];
		stosd;
		lodsd;
		adc eax, [ebx+74h];
		stosd;
		lodsd;
		adc eax, [ebx+78h];
		stosd;
		lodsd;
		adc eax, [ebx+7Ch];
		stosd;
		pushf;
		add ebx, 80h;
		jmp loopstart2;

end_fun:
		popf;
		jc ret1;
	};
	return 0;
ret1:
	return 1;
#else
	for(XL_UINT32 i = 0; i != len; ++i)
	{
		dest[i] += src[i];
		if(carry)
		{
			dest[i]++;
			carry = dest[i] <= src[i];
		}
		else
		{
			carry = dest[i] < src[i];
		}
	}
	return carry;
#endif
}


inline int i_addu32(XL_UINT32* dest, XL_UINT32 len, XL_UINT32 src)
{
#ifdef _ASM_
	__asm
	{
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		lodsd;
		add eax, [src];
		stosd;
		jnc ret0;
		pushf;
		dec ecx;
loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
loopstart2:
		sub ecx, 10h;
		jge add16;
		jmp end_fun;
add1:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		dec ecx;
		jmp loopstart;
add2:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 2h;
		jmp loopstart;
add4:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 4h;
		jmp loopstart;
add8:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 8;
		jmp loopstart;
add16:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		jmp loopstart2;
end_fun:
		popf;
		jc ret1;
ret0:
	}
	return 0;
ret1:
	return 1;
#else
	int carry = 0;
	dest[0] += src;
	if(dest[0] < src) carry = 1;
	for(XL_UINT32 i = 1; i != len; ++i)
	{
		if(carry)
		{
			dest[i]++;
			carry = dest[i] == 0;
		}
	}
	return carry;
#endif
}

inline int i_addu64(XL_UINT32* dest, XL_UINT32 len, XL_UINT64 src)
{	
	if(len == 0) return 0;
	if(len == 1)
	{
		return i_addu32(dest, len, (XL_UINT32)(src & 0xFFFFFFFF));
	}
#ifdef _ASM_
	__asm
	{
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		lodsd;
		add eax, dword ptr [src];
		stosd;
		lodsd;
		adc eax, dword ptr [src+4h];
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 2h;
loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
loopstart2:
		sub ecx, 10h;
		jge add16;
		jmp end_fun;
add1:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		dec ecx;
		jmp loopstart;
add2:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 2h;
		jmp loopstart;
add4:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 4h;
		jmp loopstart;
add8:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 8;
		jmp loopstart;
add16:
		popf;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		adc eax, 0;
		stosd;
		jnc ret0;
		pushf;
		jmp loopstart2;
end_fun:
		popf;
		jc ret1;
ret0:
	}
	return 0;
ret1:
	return 1;
#else
	XL_UINT32 i = 0;
	int carry = 0;
	dest[i] += (XL_UINT32)(src & 0xFFFFFFFF);
	if(dest[i++] < (XL_UINT32)(src & 0xFFFFFFFF)) carry = 1;
	dest[i] += (XL_UINT32)(src >> 32);
	if(carry)
	{
		dest[i]++;
		carry = dest[i++] <= (XL_UINT32)(src >> 32);
	}
	else
	{
		carry = dest[i++] < (XL_UINT32)(src >> 32);
	}
	
	for(; i != len; ++i)
	{
		if(carry)
		{
			dest[i]++;
			carry = dest[i] == 0;
		}
	}
	return carry;
#endif
}

inline int i_addu64_2(XL_UINT32* dest1, XL_UINT32 dest1Len, XL_UINT32* dest2, XL_UINT32 dest2Len, XL_UINT64 src)
{
	if(dest1Len == 0)
	{
		return i_addu64(dest2, dest2Len, src);
	}
	else if(dest1Len == 1)
	{
		int carry = i_addu32(dest1, 1, src & 0xFFFFFFFF);
		if(dest2Len) return i_addu64(dest2, dest2Len, (src >> 32) + carry);
		else return carry;
	}
	else
	{
		if(i_addu64(dest1, dest1Len, src))
		{
			if(dest2Len) return i_addu32(dest2, dest2Len, 1);
			else return 1;
		}
	}
	return 0;
}

inline int i_subs(XL_UINT32* dest, const XL_UINT32* src, XL_UINT32 len, int carry)
{
#ifdef _ASM_
	__asm
	{
		mov ebx, [src];
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		mov eax, [carry];
		test eax, eax;
		jnz setcarry;
		clc;
		pushf;
		jmp loopstart;
setcarry:
		stc;
		pushf;
loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
		test ecx, 10000b;
		jnz add16;
loopstart2:
		sub ecx, 20h;
		jge add32;
		jmp end_fun;
add1:
		popf;
		lodsd;
		sbb eax, [ebx];
		stosd;
		pushf;
		add ebx, 04h;
		dec ecx;
		jmp loopstart;

add2:
		popf;
		lodsd;
		sbb eax, [ebx];
		stosd;
		lodsd;
		sbb eax, [ebx+04h];
		stosd;
		pushf;
		add ebx, 08h;
		sub ecx, 2h;
		jmp loopstart;

add4:
		popf;
		lodsd;
		sbb eax, [ebx];
		stosd;
		lodsd;
		sbb eax, [ebx+04h];
		stosd;
		lodsd;
		sbb eax, [ebx+08h];
		stosd;
		lodsd;
		sbb eax, [ebx+0Ch];
		stosd;
		pushf;
		add ebx, 10h;
		sub ecx, 4h;
		jmp loopstart;

add8:
		popf;
		lodsd;
		sbb eax, [ebx];
		stosd;
		lodsd;
		sbb eax, [ebx+04h];
		stosd;
		lodsd;
		sbb eax, [ebx+08h];
		stosd;
		lodsd;
		sbb eax, [ebx+0Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+10h];
		stosd;
		lodsd;
		sbb eax, [ebx+14h];
		stosd;
		lodsd;
		sbb eax, [ebx+18h];
		stosd;
		lodsd;
		sbb eax, [ebx+1Ch];
		stosd;
		pushf;
		add ebx, 20h;
		sub ecx, 8h;
		jmp loopstart;

add16:
		popf;
		lodsd;
		sbb eax, [ebx];
		stosd;
		lodsd;
		sbb eax, [ebx+04h];
		stosd;
		lodsd;
		sbb eax, [ebx+08h];
		stosd;
		lodsd;
		sbb eax, [ebx+0Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+10h];
		stosd;
		lodsd;
		sbb eax, [ebx+14h];
		stosd;
		lodsd;
		sbb eax, [ebx+18h];
		stosd;
		lodsd;
		sbb eax, [ebx+1Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+20h];
		stosd;
		lodsd;
		sbb eax, [ebx+24h];
		stosd;
		lodsd;
		sbb eax, [ebx+28h];
		stosd;
		lodsd;
		sbb eax, [ebx+2Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+30h];
		stosd;
		lodsd;
		sbb eax, [ebx+34h];
		stosd;
		lodsd;
		sbb eax, [ebx+38h];
		stosd;
		lodsd;
		sbb eax, [ebx+3Ch];
		stosd;
		pushf;
		add ebx, 40h;
		sub ecx, 10h;
		jmp loopstart;

add32:
		popf;
		lodsd;
		sbb eax, [ebx];
		stosd;
		lodsd;
		sbb eax, [ebx+04h];
		stosd;
		lodsd;
		sbb eax, [ebx+08h];
		stosd;
		lodsd;
		sbb eax, [ebx+0Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+10h];
		stosd;
		lodsd;
		sbb eax, [ebx+14h];
		stosd;
		lodsd;
		sbb eax, [ebx+18h];
		stosd;
		lodsd;
		sbb eax, [ebx+1Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+20h];
		stosd;
		lodsd;
		sbb eax, [ebx+24h];
		stosd;
		lodsd;
		sbb eax, [ebx+28h];
		stosd;
		lodsd;
		sbb eax, [ebx+2Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+30h];
		stosd;
		lodsd;
		sbb eax, [ebx+34h];
		stosd;
		lodsd;
		sbb eax, [ebx+38h];
		stosd;
		lodsd;
		sbb eax, [ebx+3Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+40h];
		stosd;
		lodsd;
		sbb eax, [ebx+44h];
		stosd;
		lodsd;
		sbb eax, [ebx+48h];
		stosd;
		lodsd;
		sbb eax, [ebx+4Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+50h];
		stosd;
		lodsd;
		sbb eax, [ebx+54h];
		stosd;
		lodsd;
		sbb eax, [ebx+58h];
		stosd;
		lodsd;
		sbb eax, [ebx+5Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+60h];
		stosd;
		lodsd;
		sbb eax, [ebx+64h];
		stosd;
		lodsd;
		sbb eax, [ebx+68h];
		stosd;
		lodsd;
		sbb eax, [ebx+6Ch];
		stosd;
		lodsd;
		sbb eax, [ebx+70h];
		stosd;
		lodsd;
		sbb eax, [ebx+74h];
		stosd;
		lodsd;
		sbb eax, [ebx+78h];
		stosd;
		lodsd;
		sbb eax, [ebx+7Ch];
		stosd;
		pushf;
		add ebx, 80h;
		jmp loopstart2;

end_fun:
		popf;
		cld;
		jc ret1;
	};
	return 0;
ret1:
	return 1;
#else

	for(XL_UINT32 i = 0; i != len; ++i)
	{
		if(carry)
		{
			carry = dest[i] <= src[i];
			dest[i]--;
		}
		else
		{
			carry = dest[i] < src[i];
		}
		dest[i] -= src[i];
	}
	return carry;
#endif
}

inline int i_subu32(XL_UINT32* dest, XL_UINT32 len, XL_UINT32 src)
{
#ifdef _ASM_
	__asm
	{
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		lodsd;
		sub eax, [src];
		stosd;
		jnc ret0;
		pushf;
		dec ecx;
loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
loopstart2:
		sub ecx, 10h;
		jge add16;
		jmp end_fun;
add1:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		dec ecx;
		jmp loopstart;
add2:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 2h;
		jmp loopstart;
add4:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 4h;
		jmp loopstart;
add8:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 8;
		jmp loopstart;
add16:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		jmp loopstart2;
end_fun:
		popf;
		jc ret1;
ret0:
	}
	return 0;
ret1:
	return 1;
#else
	int carry = 0;
	if(dest[0] < src) carry = 1;
	dest[0] -= src;
	for(XL_UINT32 i = 1; i != len; ++i)
	{
		if(carry)
		{
			carry = dest[i] == 0;
			dest[i]--;
		}
	}
	return carry;
#endif
}

inline int i_subu64(XL_UINT32* dest, XL_UINT32 len, XL_UINT64 src)
{
	if(len == 0) return 0;
	if(len == 1)
	{
		return i_subu32(dest, len, (XL_UINT32)(src & 0xFFFFFFFF));
	}

#ifdef _ASM_
	__asm
	{
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		lodsd;
		sub eax, dword ptr [src];
		stosd;
		lodsd;
		sbb eax, dword ptr [src+4h];
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 2h;
loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
loopstart2:
		sub ecx, 10h;
		jge add16;
		jmp end_fun;
add1:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		dec ecx;
		jmp loopstart;
add2:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 2h;
		jmp loopstart;
add4:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 4h;
		jmp loopstart;
add8:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		sub ecx, 8;
		jmp loopstart;
add16:
		popf;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		lodsd;
		sbb eax, 0;
		stosd;
		jnc ret0;
		pushf;
		jmp loopstart2;
end_fun:
		popf;
		jc ret1;
ret0:
	}
	return 0;
ret1:
	return 1;
#else
	int carry = 0;
	XL_UINT32 i = 0;
	carry = dest[i] < (XL_UINT32)(src & 0xFFFFFFFF);
	dest[i++] -= (XL_UINT32)(src & 0xFFFFFFFF);
	if(carry)
	{
		dest[i]--;
		carry = dest[i] == (XL_UINT32)(-1) || dest[i] < (XL_UINT32)(src >> 32);
	}
	else
	{
		carry = dest[i] < (XL_UINT32)(src >> 32);
	}
	dest[i++] -= (XL_UINT32)(src >> 32);
	
	for(; i != len; ++i)
	{
		if(carry)
		{
			carry = dest[i] == 0;
			dest[i]--;
		}
	}
	return carry;
#endif
}

inline int i_subu64_2(XL_UINT32* dest1, XL_UINT32 dest1Len, XL_UINT32* dest2, XL_UINT32 dest2Len, XL_UINT64 src)
{
	if(dest1Len == 0)
	{
		return i_subu64(dest2, dest2Len, src);
	}
	else if(dest1Len == 1)
	{
		int carry = i_subu32(dest1, 1, src & 0xFFFFFFFF);
		if(dest2Len) return i_subu64(dest2, dest2Len, (src >> 32) + carry);
		else return carry;
	}
	else
	{
		if(i_subu64(dest1, dest1Len, src))
		{
			if(dest2Len) return i_subu32(dest2, dest2Len, 1);
			else return 1;
		}
	}
	return 0;
}

inline int i_cmplt(XL_UINT32* dest, XL_UINT32 len, int carry)
{
	XL_UINT32 i = 0;
	if(carry == 0)
	{
		for(; i != len; ++i)
		{
			if(dest[i] > 0)
			{
				dest[i]--;
				carry = 1;
				break;
			}
		}
	}
	for(; i != len; ++i)
	{
		dest[i] = ~dest[i];
	}
	return carry;
}

inline int i_cmps(const XL_UINT32* dest, const XL_UINT32* src, XL_UINT32 len)
{
	for(XL_UINT32 i = len - 1; i != (XL_UINT32)(-1); --i)
	{
		if(dest[i] < src[i]) return -1;
		if(dest[i] > src[i]) return 1;
	}
	return 0;
}

inline int i_cmps2(const XL_UINT32* dest1, XL_UINT32 destSep, const XL_UINT32* dest2, const XL_UINT32* src1, XL_UINT32 srcSep, const XL_UINT32* src2, XL_UINT32 len)
{
	XL_UINT32 i = len - 1;

	if(i < destSep && i < srcSep) goto d1s1;
	if(i < destSep && i >= srcSep) goto d1s2;
	if(i >= destSep && i < srcSep) goto d2s1;

	for(; i != destSep-1 && i != srcSep-1; --i)
	{
		XL_UINT32 dV = dest2[i - destSep];
		XL_UINT32 sV = src2[i - srcSep];

		if(dV < sV) return -1;
		if(dV > sV) return 1;
	}
	if(i < destSep && i < srcSep) goto d1s1;
	if(i < destSep) goto d1s2;
	if(i < srcSep) goto d2s1;

d2s1:
	for(; i != (XL_UINT32)(-1) && i != destSep-1; --i)
	{
		XL_UINT32 dV = dest2[i - destSep];
		XL_UINT32 sV = src1[i];

		if(dV < sV) return -1;
		if(dV > sV) return 1;
	}
	goto d1s1;

d1s2:
	for(; i != (XL_UINT32)(-1) && i != srcSep-1; --i)
	{
		XL_UINT32 dV = dest1[i];
		XL_UINT32 sV = src2[i - srcSep];

		if(dV < sV) return -1;
		if(dV > sV) return 1;
	}
	goto d1s1;

d1s1:
	for(; i != (XL_UINT32)(-1); --i)
	{
		XL_UINT32 dV = dest1[i];
		XL_UINT32 sV = src1[i];

		if(dV < sV) return -1;
		if(dV > sV) return 1;
	}
	return 0;
}

inline void i_shr1(XL_UINT32* dest, XL_UINT32 len)
{
	__asm
	{
		mov edi, [dest];
		mov esi, edi;
		mov ecx, [len];
		clc;
		pushf;

loopstart:
		test ecx, 00001b;
		jnz add1;
		test ecx, 00010b;
		jnz add2;
		test ecx, 00100b;
		jnz add4;
		test ecx, 01000b;
		jnz add8;
loopstart2:
		sub ecx, 10h;
		jge add16;
		jmp end_fun;
add1:
		popf;
		lodsd;
		rcr eax, 1;
		stosd;
		pushf;
		sub ebx, 04h;
		dec ecx;
		jmp loopstart;

add2:
		popf;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		pushf;
		sub ebx, 08h;
		sub ecx, 2h;
		jmp loopstart;

add4:
		popf;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		pushf;
		sub ebx, 10h;
		sub ecx, 4h;
		jmp loopstart;

add8:
		popf;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		pushf;
		sub ebx, 20h;
		sub ecx, 8h;
		jmp loopstart;

add16:
		popf;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		lodsd;
		rcr eax, 1;
		stosd;
		pushf;
		sub ebx, 40h;
		jmp loopstart2;

end_fun:
		popf;
	};
}

/*
inline void i_shlcopys(XL_UINT32* dest, XL_UINT32* src, XL_UINT32 shift, XL_UINT32 dlen, XL_UINT32 slen)
{
	XL_UINT32 w = shift >> 5;
	shift = shift & 31;
	if(dlen + w < slen) slen = dlen + w;
	if(w >= dlen)
	{
		memset(dest, 0, SIZE_TO_BYTE(dlen));
		return;
	}
	if(shift)
	{
		dest[0] = src[w] << shift;
		for(XL_UINT32 i = w + 1; i < slen; ++i)
		{
			dest[i - w - 1] |= src[i] >> (32 - shift);
			dest[i - w] = src[i] << shift;
		}
	}
	else
	{
		for(XL_UINT32 i = w; i < slen; ++i)
		{
			dest[i - w] = src[i];
		}
	}
	if(slen > w)
	{
		memset(dest + slen - w, 0, SIZE_TO_BYTE(dlen - slen + w));
	}
}

inline void i_shrcopys(XL_UINT32* dest, XL_UINT32* src, XL_UINT32 shift, XL_UINT32 dlen, XL_UINT32 slen)
{
	XL_UINT32 w = shift >> 5;
	shift = shift & 31;
	if(dlen - w < slen) slen = dlen - w;
	if(w >= dlen)
	{
		memset(dest, 0, SIZE_TO_BYTE(slen));
		return;
	}
	if(shift)
	{
		dest[slen - 1 + w] = src[slen - 1] >> shift;
		for(XL_UINT32 i = slen - 2; i != (XL_UINT32)(-1); --i)
		{
			dest[i + w + 1] |= src[i] << (32-shift);
			dest[i + w] = src[i] >> shift;
		}
	}
	else
	{
		for(XL_UINT32 i = slen - 1; i != (XL_UINT32)(-1); --i)
		{
			dest[i + w] = src[i] >> shift;
		}
	}
	memset(dest, 0, SIZE_TO_BYTE(w));
	if(slen + w < dlen) memset(dest + slen + w, 0, SIZE_TO_BYTE(dlen - slen -w));
}
*/


inline XL_UINT32 i_bsu(XL_UINT32 u)
{
	XL_UINT32 r;
	if(_BitScanReverse(&r, u)) return r;
	return (XL_UINT32)-1;
}

inline XL_UINT32 i_bss(const XL_UINT32* dest, XL_UINT32 len)
{
	for(XL_UINT32 i = len - 1; i != (XL_UINT32)-1; --i)
	{
		XL_UINT32 r;
		if(_BitScanReverse(&r, dest[i])) return r + (i << 5);
	}
	return (XL_UINT32)(-1);
}

inline XL_UINT32 i_cmpzero(const XL_UINT32* dest, XL_UINT32 len)
{
	for(XL_UINT32 i = 0; i < len; ++i)
	{
		if(dest[i]) return 0;
	}
	return 1;
}


inline void i_shl(XL_UINT32* dest, XL_UINT32 len, XL_UINT32 count)
{
	__asm{
		std;
		mov esi, [len];
		shl esi, 2h;
		add esi, [dest];
		sub esi, 8h;
		mov edx, [len];
		dec edx;
		mov cl, byte ptr [count];
loopstart:
		test edx, 00001b;
		jnz sh1;
		test edx, 00010b;
		jnz sh2;
		test edx, 00100b;
		jnz sh4;
		test edx, 01000b;
		jnz sh8;
loopstart2:
		sub edx, 10h;
		jge sh16;
		jmp end_fun;
sh1:
		lodsd;
		shld [esi+8h], eax, cl;
		dec edx;
		jmp loopstart;
sh2:
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		sub edx, 2h;
		jmp loopstart;
sh4:
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		sub edx, 4h;
		jmp loopstart;
sh8:
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		sub edx, 8h;
		jmp loopstart;
sh16:
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		lodsd;
		shld [esi+8h], eax, cl;
		jmp loopstart2;
end_fun:
		shl dword ptr [esi+4h], cl;
		cld;
	}
}


inline XL_UINT32 i_shrs(XL_UINT32* dest, XL_UINT32 len, XL_UINT32 shift, XL_UINT32 fill)
{
	if(!shift) return 0;

	XL_UINT32 rem = dest[0] << (32 - shift);
	dest[0] = dest[0] >> shift;
	for(XL_UINT32 i = 1; i < len; ++i)
	{
		dest[i - 1] |= dest[i] << (32 - shift);
		dest[i] = dest[i] >> shift;
	}
	dest[len - 1] |= fill;

	return rem;
}

inline XL_UINT32 i_shls(XL_UINT32* dest, XL_UINT32 len, XL_UINT32 shift, XL_UINT32 fill)
{	
	if(!shift) return 0;

	XL_UINT32 rem = dest[len - 1] >> (32 - shift);
	dest[len - 1] = dest[len - 1] << shift;
	for(XL_UINT32 i = len - 2; i != (XL_UINT32)(-1); --i)
	{
		dest[i + 1] |= dest[i] >> (32-shift);
		dest[i] = dest[i] << shift;
	}
	dest[0] |= fill;

	return rem;
}

inline XL_UINT64 i_64(XL_UINT32 high, XL_UINT32 low)
{
	return (XL_UINT64)high << 32 | low;
}

inline XL_UINT32 i_div64(XL_UINT64 a, XL_UINT32 divisor, XL_UINT32* quot)
{
	*quot = a / divisor;
	return (XL_UINT32)(a % divisor);
}