/*

XLarge Project

Written by Integralus, 2013.10.26
E-mail: bab2min@gmail.com
Homepage: http://bab2min.tistory.com/

*/

#pragma once

typedef unsigned long XL_UINT32;
typedef unsigned long long XL_UINT64;
typedef long XL_INT32;
typedef long long XL_INT64;

typedef struct _tagXLarge
{
	XL_UINT32* frac;
	XL_UINT32 size;
	XL_UINT32 begin;
	XL_UINT32 end;
	XL_INT32 exp;
	XL_UINT32 sign;
} XLarge;

typedef XLarge* PXLARGE;
typedef XLarge const* PCXLARGE;

PXLARGE xl_create(XL_UINT32 size);
PXLARGE xl_createcopy(PCXLARGE src);
void xl_delete(PXLARGE pxl);

void xl_move(PXLARGE dest, PCXLARGE src);
void xl_init(PXLARGE dest, XL_INT32 value);
void xl_init1(PXLARGE dest, XL_UINT32 value);
void xl_swap(PXLARGE a, PXLARGE b);

void xl_setnan(PXLARGE pxl);
int xl_isnan(PCXLARGE pxl);

void xl_add(PXLARGE dest, PCXLARGE src);
void xl_add1(PXLARGE dest, XL_UINT32 src);
void xl_sub(PXLARGE dest, PCXLARGE src);
void xl_sub1(PXLARGE dest, XL_UINT32 src);
void xl_neg(PXLARGE dest);
int xl_cmp(PCXLARGE a, PCXLARGE b);
int xl_cmpzero(PCXLARGE a);
int xl_cmpnearzero(PCXLARGE a, XL_INT32 exp);

void xl_mul(PXLARGE dest, PCXLARGE a, PCXLARGE b);
void xl_mul1(PXLARGE dest, PCXLARGE a, XL_UINT32 b);

void xl_muladd(PXLARGE dest, PCXLARGE a, PCXLARGE b);
void xl_mulsub(PXLARGE dest, PCXLARGE a, PCXLARGE b);

void xl_shl(PXLARGE dest, XL_UINT32 bit);
void xl_shr(PXLARGE dest, XL_UINT32 bit);

void xl_mod(PCXLARGE dest, PCXLARGE divisor, PXLARGE quot, PXLARGE remainder);
XL_UINT32 xl_mod1(PCXLARGE dest, XL_UINT32 divisor, PXLARGE quot);
void xl_inv(PXLARGE dest, PCXLARGE a, XL_UINT32 precision);

void xl_sqrt(PXLARGE dest, PCXLARGE a, XL_UINT32 precision);
void xl_exp(PXLARGE dest, PCXLARGE a, XL_UINT32 precision);
void xl_log(PXLARGE dest, PCXLARGE a, XL_UINT32 precision);
void xl_pow(PXLARGE dest, PCXLARGE base, PCXLARGE exp, XL_UINT32 precision);

void xl_sin(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_cos(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_tan(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_asin(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_acos(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_atan(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);

void xl_sinh(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_cosh(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_tanh(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_asinh(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_acosh(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);
void xl_atanh(PXLARGE dest, PCXLARGE rad, XL_UINT32 precision);

void xl_pi(PXLARGE dest, XL_UINT32 precision);

void xl_modf(PXLARGE integer, PXLARGE fraction, PCXLARGE pxl);
int xl_isinteger(PCXLARGE dest);
void xl_round(PXLARGE dest, XL_UINT32 precision);
void xl_printx(PCXLARGE pxl, FILE* file);
void xl_print(PCXLARGE pxl, FILE* file, XL_UINT32 precision);
void xl_atof(PXLARGE pxl, const char* str, XL_UINT32 precision);

#ifdef XL_DEBUGINFO
typedef struct _tagXLDebugInfo
{
	int growCount;
} XLDebugInfo;

XLDebugInfo* xl_getdebuginfo();
#endif